package com.yunzhupaas.mdm.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import com.yunzhupaas.base.ActionResult;
import com.yunzhupaas.base.UserInfo;
import com.yunzhupaas.exception.DataException;
import com.yunzhupaas.permission.entity.UserEntity;
import com.yunzhupaas.constant.MsgCode;
import com.yunzhupaas.mdm.service.*;
import com.yunzhupaas.mdm.entity.*;
import com.yunzhupaas.util.*;
import com.yunzhupaas.mdm.model.asset.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yunzhupaas.flowable.entity.TaskEntity;
import jakarta.validation.Valid;
import java.util.*;
import com.yunzhupaas.model.ExcelModel;
import com.yunzhupaas.excel.ExcelExportStyler;
import com.yunzhupaas.excel.ExcelHelper;
import com.yunzhupaas.annotation.YunzhupaasField;
import com.yunzhupaas.base.vo.PageListVO;
import com.yunzhupaas.base.vo.PaginationVO;
import com.yunzhupaas.base.vo.DownloadVO;
import com.yunzhupaas.config.ConfigValueUtil;
import com.yunzhupaas.base.entity.ProvinceEntity;
import java.io.IOException;
import java.util.stream.Collectors;
import com.yunzhupaas.flowable.entity.TaskEntity;
import com.yunzhupaas.exception.WorkFlowException;
import com.yunzhupaas.model.visualJson.UploaderTemplateModel;
import com.yunzhupaas.base.util.FormExecelUtils;
import org.springframework.web.multipart.MultipartFile;
import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.ExcelImportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import cn.afterturn.easypoi.excel.entity.ImportParams;
import cn.afterturn.easypoi.excel.entity.params.ExcelExportEntity;
import cn.afterturn.easypoi.excel.entity.enmus.ExcelType;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import com.yunzhupaas.onlinedev.model.ExcelImFieldModel;
import com.yunzhupaas.base.model.OnlineImport.ImportDataModel;
import com.yunzhupaas.base.model.OnlineImport.ImportFormCheckUniqueModel;
import com.yunzhupaas.base.model.OnlineImport.ExcelImportModel;
import com.yunzhupaas.base.model.OnlineImport.VisualImportModel;
import cn.xuyanwu.spring.file.storage.FileInfo;
import lombok.Cleanup;
import com.yunzhupaas.model.visualJson.config.HeaderModel;
import com.yunzhupaas.base.model.ColumnDataModel;
import com.yunzhupaas.base.util.VisualUtils;
import org.springframework.transaction.annotation.Transactional;

/**
 * 资产信息
 * @版本： V5.2.7
 * @版权： Copyright @ 2025  深圳市乐程软件有限公司版权所有
 * @作者： 深圳市乐程软件有限公司
 * @日期： 2026-04-28
 */
@Slf4j
@RestController
@Tag(name = "资产信息" , description = "bcm")
@RequestMapping("/api/bcm/Asset")
public class AssetController {

    @Autowired
    private GeneraterSwapUtil generaterSwapUtil;

    @Autowired
    private UserProvider userProvider;

    @Autowired
    private AssetService assetService;

    @Autowired
    private SuppinfoService companyService;

    @Autowired
    private ConfigValueUtil configValueUtil;

    /**
     * 列表
     *
     * @param assetPagination
     * @return
     */
    @Operation(summary = "获取列表")
    @PostMapping("/getList")
    public ActionResult list(@RequestBody AssetPagination assetPagination)throws Exception{
        List<AssetEntity> list= assetService.getList(assetPagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (AssetEntity entity : list) {
            Map<String, Object> assetMap=JsonUtil.entityToMap(entity);
            assetMap.put("id", assetMap.get("asset_id"));
            //副表数据
            //子表数据
            realList.add(assetMap);
        }
        //数据转换
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        realList = generaterSwapUtil.swapDataList(realList, AssetConstant.getFormData(), AssetConstant.getColumnData(), assetPagination.getModuleId(),isPc?false:false);
        for (Map<String, Object> map : realList) {
            if(ObjectUtil.isNotEmpty( map.get("supplier_id"))){
                map.put("supplier_id", companyService.getInfo(map.get("supplier_id").toString()).getCompanyName());
            }

        }
        //返回对象
        PageListVO vo = new PageListVO();
        vo.setList(realList);
        PaginationVO page = JsonUtil.getJsonToBean(assetPagination, PaginationVO.class);
        vo.setPagination(page);
        return ActionResult.success(vo);
    }
    /**
     * 创建
     *
     * @param assetForm
     * @return
     */
    @PostMapping()
    @Operation(summary = "创建")
    public ActionResult create(@RequestBody @Valid AssetForm assetForm) {
        String b = assetService.checkForm(assetForm,0);
        if (StringUtil.isNotEmpty(b)){
            return ActionResult.fail(b );
        }
        try{
            assetService.saveOrUpdate(assetForm, null ,true);
        }catch(Exception e){
            return ActionResult.fail(MsgCode.FA028.get());
        }
        return ActionResult.success(MsgCode.SU001.get());
    }
    /**
     * 导出Excel
     *
     * @return
     */
    @Operation(summary = "导出Excel")
    @PostMapping("/Actions/Export")
    public ActionResult Export(@RequestBody AssetPagination assetPagination) throws IOException {
        if (StringUtil.isEmpty(assetPagination.getSelectKey())){
            return ActionResult.fail(MsgCode.IMP011.get());
        }
        List<AssetEntity> list= assetService.getList(assetPagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (AssetEntity entity : list) {
            Map<String, Object> assetMap=JsonUtil.entityToMap(entity);
            assetMap.put("id", assetMap.get("asset_id"));
            //副表数据
            //子表数据
            realList.add(assetMap);
        }
        //数据转换
        realList = generaterSwapUtil.swapDataList(realList, AssetConstant.getFormData(), AssetConstant.getColumnData(), assetPagination.getModuleId(),false);
        String[]keys=!StringUtil.isEmpty(assetPagination.getSelectKey())?assetPagination.getSelectKey():new String[0];
        UserInfo userInfo=userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(assetPagination.getMenuId());

        DownloadVO vo=this.creatModelExcel(configValueUtil.getTemporaryFilePath(),realList,keys,userInfo,menuFullName);
        return ActionResult.success(vo);
    }

    /**
     * 导出表格方法
     */
    public DownloadVO creatModelExcel(String path,List<Map<String, Object>>list,String[]keys,UserInfo userInfo,String menuFullName){
        DownloadVO vo=DownloadVO.builder().build();
        List<ExcelExportEntity> entitys=new ArrayList<>();
        if(keys.length>0){
            for(String key:keys){
                switch(key){
                    case "asset_code" :
                        entitys.add(new ExcelExportEntity("资产编码" ,"asset_code"));
                        break;
                    case "asset_name" :
                        entitys.add(new ExcelExportEntity("资产名称" ,"asset_name"));
                        break;
                    case "asset_type" :
                        entitys.add(new ExcelExportEntity("资产类型" ,"asset_type"));
                        break;
                    case "asset_category" :
                        entitys.add(new ExcelExportEntity("资产分类" ,"asset_category"));
                        break;
                    case "asset_status" :
                        entitys.add(new ExcelExportEntity("资产状态" ,"asset_status"));
                        break;
                    case "asset_location" :
                        entitys.add(new ExcelExportEntity("资产位置" ,"asset_location"));
                        break;
                    case "current_org_id" :
                        entitys.add(new ExcelExportEntity("使用组织" ,"current_org_id"));
                        break;
                    case "current_user_id" :
                        entitys.add(new ExcelExportEntity("保管用户" ,"current_user_id"));
                        break;
                    case "asset_ownership" :
                        entitys.add(new ExcelExportEntity("资产权属" ,"asset_ownership"));
                        break;
                    case "measurement_unit" :
                        entitys.add(new ExcelExportEntity("单位" ,"measurement_unit"));
                        break;
                    case "quantity" :
                        entitys.add(new ExcelExportEntity("数量" ,"quantity"));
                        break;
                    case "purchase_date" :
                        entitys.add(new ExcelExportEntity("购置日期" ,"purchase_date"));
                        break;
                    case "commissioning_date" :
                        entitys.add(new ExcelExportEntity("启用日期" ,"commissioning_date"));
                        break;
                    case "expected_life" :
                        entitys.add(new ExcelExportEntity("预计使用年限" ,"expected_life"));
                        break;
                    case "supplier_id" :
                        entitys.add(new ExcelExportEntity("供应商" ,"supplier_id"));
                        break;
                    case "remark" :
                        entitys.add(new ExcelExportEntity("备注" ,"remark"));
                        break;
                    default:
                        break;
                }
            }
        }

        ExportParams exportParams = new ExportParams(null, "表单信息");
        exportParams.setType(ExcelType.XSSF);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //去除空数据
                List<Map<String, Object>> dataList = new ArrayList<>();
                for (Map<String, Object> map : list) {
                    int i = 0;
                    for (String key : keys) {
                        //子表
                        if (key.toLowerCase().startsWith("tablefield")) {
                            String tableField = key.substring(0, key.indexOf("-" ));
                            String field = key.substring(key.indexOf("-" ) + 1);
                            Object o = map.get(tableField);
                            if (o != null) {
                                List<Map<String, Object>> childList = (List<Map<String, Object>>) o;
                                for (Map<String, Object> childMap : childList) {
                                    if (childMap.get(field) != null) {
                                        i++;
                                    }
                                }
                            }
                        } else {
                            Object o = map.get(key);
                            if (o != null) {
                                i++;
                            }
                        }
                    }
                    if (i > 0) {
                        dataList.add(map);
                    }
                }
                List<ExcelExportEntity> mergerEntitys = new ArrayList<>(entitys);
                List<Map<String, Object>> mergerList=new ArrayList<>(dataList);
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(AssetConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                    dataList =  VisualUtils.complexHeaderDataHandel(dataList, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                }

                exportParams.setStyle(ExcelExportStyler.class);
                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, dataList);
                VisualUtils.mergerVertical(workbook, mergerEntitys, mergerList);
                ExcelModel excelModel = generaterSwapUtil.getExcelParams(AssetConstant.getFormData(),Arrays.asList(keys));
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }
            String fileName = menuFullName  +"_"+ DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            log.error("信息导出Excel错误:{}", e.getMessage());
            e.printStackTrace();
        }
        return vo;
    }
    @Operation(summary = "上传文件")
    @PostMapping("/Uploader")
    public ActionResult<Object> Uploader() {
        List<MultipartFile> list = UpUtil.getFileAll();
        MultipartFile file = list.get(0);
        if (file.getOriginalFilename().endsWith(".xlsx") || file.getOriginalFilename().endsWith(".xls")) {
            String filePath = XSSEscape.escape(configValueUtil.getTemporaryFilePath());
            String fileName = XSSEscape.escape(RandomUtil.uuId() + "." + UpUtil.getFileType(file));
            //上传文件
            FileInfo fileInfo = FileUploadUtils.uploadFile(file, filePath, fileName);
            DownloadVO vo = DownloadVO.builder().build();
            vo.setName(fileInfo.getFilename());
            return ActionResult.success(vo);
        } else {
            return ActionResult.fail(MsgCode.FA017.get());
        }
    }

    /**
     * 模板下载
     *
     * @return
     */
    @Operation(summary = "模板下载")
    @GetMapping("/TemplateDownload")
    public ActionResult<DownloadVO>  TemplateDownload(@RequestParam("menuId") String menuId){
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(menuId);
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
        entitys.add(new ExcelExportEntity("资产名称(asset_name)" ,"asset_name"));
        selectKeys.add("asset_name");
        entitys.add(new ExcelExportEntity("资产类型(asset_type)" ,"asset_type"));
        selectKeys.add("asset_type");
        entitys.add(new ExcelExportEntity("资产分类(asset_category)" ,"asset_category"));
        selectKeys.add("asset_category");
        entitys.add(new ExcelExportEntity("资产状态(asset_status)" ,"asset_status"));
        selectKeys.add("asset_status");
        entitys.add(new ExcelExportEntity("资产权属(asset_ownership)" ,"asset_ownership"));
        selectKeys.add("asset_ownership");
        entitys.add(new ExcelExportEntity("资产位置(asset_location)" ,"asset_location"));
        selectKeys.add("asset_location");
        entitys.add(new ExcelExportEntity("使用组织(current_org_id)" ,"current_org_id"));
        selectKeys.add("current_org_id");
        entitys.add(new ExcelExportEntity("单位(measurement_unit)" ,"measurement_unit"));
        selectKeys.add("measurement_unit");
        entitys.add(new ExcelExportEntity("启用日期(commissioning_date)" ,"commissioning_date"));
        selectKeys.add("commissioning_date");
        entitys.add(new ExcelExportEntity("购置日期(purchase_date)" ,"purchase_date"));
        selectKeys.add("purchase_date");
        entitys.add(new ExcelExportEntity("备注(remark)" ,"remark"));
        selectKeys.add("remark");
        entitys.add(new ExcelExportEntity("预计使用年限(expected_life)" ,"expected_life"));
        selectKeys.add("expected_life");
        entitys.add(new ExcelExportEntity("数量(quantity)" ,"quantity"));
        selectKeys.add("quantity");
        entitys.add(new ExcelExportEntity("保管用户(current_user_id)" ,"current_user_id"));
        selectKeys.add("current_user_id");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(AssetConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.add(excelModel.getDataMap());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(AssetConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                    list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
                }
                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }
            String fileName = menuFullName + "导入模板.xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            log.error("模板信息导出Excel错误:{}", e.getMessage());
            e.printStackTrace();
        }
        return ActionResult.success(vo);
    }

    /**
     * 导入预览
     *
     * @return
     */
    @Operation(summary = "导入预览" )
    @GetMapping("/ImportPreview")
    public ActionResult<Map<String, Object>> ImportPreview(String fileName) throws Exception {
        Map<String, Object> headAndDataMap = new HashMap<>(2);
        String filePath = FileUploadUtils.getLocalBasePath() + configValueUtil.getTemporaryFilePath();
        FileUploadUtils.downLocal(configValueUtil.getTemporaryFilePath(), filePath, fileName);
        File temporary = new File(XSSEscape.escapePath(filePath + fileName));
        int headerRowIndex = 1;
        ImportParams params = new ImportParams();
        params.setTitleRows(0);
        params.setHeadRows(headerRowIndex);
        params.setNeedVerify(true);
        try {
            InputStream inputStream = ExcelUtil.solveOrginTitle(temporary, headerRowIndex);
            List<Map> excelDataList = ExcelUtil.importExcelByInputStream(inputStream, 0, headerRowIndex, Map.class);
            //数据超过1000条
            if(excelDataList != null && excelDataList.size() > 1000) {
                return ActionResult.fail(MsgCode.ETD117.get());
            }

            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(AssetConstant.getColumnData(), ColumnDataModel.class);
            UploaderTemplateModel uploaderTemplateModel = JsonUtil.getJsonToBean(columnDataModel.getUploaderTemplateJson(), UploaderTemplateModel.class);
            List<String> selectKey = uploaderTemplateModel.getSelectKey();
            //子表合并
            List<Map<String, Object>> results = FormExecelUtils.dataMergeChildTable(excelDataList,selectKey);
            // 导入字段
            List<ExcelImFieldModel> columns = new ArrayList<>();
            columns.add(new ExcelImFieldModel("asset_name","资产名称","input"));
            columns.add(new ExcelImFieldModel("asset_type","资产类型","select"));
            columns.add(new ExcelImFieldModel("asset_category","资产分类","select"));
            columns.add(new ExcelImFieldModel("asset_status","资产状态","select"));
            columns.add(new ExcelImFieldModel("asset_ownership","资产权属","select"));
            columns.add(new ExcelImFieldModel("asset_location","资产位置","cascader"));
            columns.add(new ExcelImFieldModel("current_org_id","使用组织","organizeSelect"));
            columns.add(new ExcelImFieldModel("measurement_unit","单位","input"));
            columns.add(new ExcelImFieldModel("commissioning_date","启用日期","datePicker"));
            columns.add(new ExcelImFieldModel("purchase_date","购置日期","datePicker"));
            columns.add(new ExcelImFieldModel("remark","备注","textarea"));
            columns.add(new ExcelImFieldModel("expected_life","预计使用年限","inputNumber"));
            columns.add(new ExcelImFieldModel("quantity","数量","inputNumber"));
            columns.add(new ExcelImFieldModel("current_user_id","保管用户","userSelect"));
            headAndDataMap.put("dataRow" , results);
            headAndDataMap.put("headerRow" , JsonUtil.getJsonToList(JsonUtil.getListToJsonArray(columns)));
        } catch (Exception e){
            e.printStackTrace();
            return ActionResult.fail(MsgCode.VS407.get());
        }
        return ActionResult.success(headAndDataMap);
    }

    /**
     * 导入数据
     *
     * @return
     */
    @Operation(summary = "导入数据" )
    @PostMapping("/ImportData")
    public ActionResult<ExcelImportModel> ImportData(@RequestBody VisualImportModel visualImportModel) throws Exception {
        List<Map<String, Object>> listData = visualImportModel.getList();
        ImportFormCheckUniqueModel uniqueModel = new ImportFormCheckUniqueModel();
        uniqueModel.setDbLinkId(AssetConstant.DBLINKID);
        uniqueModel.setUpdate(Objects.equals("1", "2"));

        Map<String,String> tablefieldkey = new HashMap<>();
        for(String key:AssetConstant.TABLEFIELDKEY.keySet()){
            tablefieldkey.put(key,AssetConstant.TABLERENAMES.get(AssetConstant.TABLEFIELDKEY.get(key)));
        }
        ExcelImportModel excelImportModel = generaterSwapUtil.importData(AssetConstant.getFormData(),listData,uniqueModel, tablefieldkey,AssetConstant.getTableList());
        List<ImportDataModel> importDataModel = uniqueModel.getImportDataModel();
        for (ImportDataModel model : importDataModel) {
            String id = model.getId();
            Map<String, Object> result = model.getResultData();
            if(StringUtil.isNotEmpty(id)){
                update(id, JsonUtil.getJsonToBean(result,AssetForm.class), true);
            }else {
                create( JsonUtil.getJsonToBean(result,AssetForm.class));
            }
        }
        return ActionResult.success(excelImportModel);
    }

    /**
     * 导出异常报告
     *
     * @return
     */
    @Operation(summary = "导出异常报告")
    @PostMapping("/ImportExceptionData")
    public ActionResult<DownloadVO> ImportExceptionData(@RequestBody VisualImportModel visualImportModel) {
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(visualImportModel.getMenuId());
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        entitys.add(new ExcelExportEntity("异常原因", "errorsInfo",30));
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
        entitys.add(new ExcelExportEntity("资产名称(asset_name)" ,"asset_name"));
        selectKeys.add("asset_name");
        entitys.add(new ExcelExportEntity("资产类型(asset_type)" ,"asset_type"));
        selectKeys.add("asset_type");
        entitys.add(new ExcelExportEntity("资产分类(asset_category)" ,"asset_category"));
        selectKeys.add("asset_category");
        entitys.add(new ExcelExportEntity("资产状态(asset_status)" ,"asset_status"));
        selectKeys.add("asset_status");
        entitys.add(new ExcelExportEntity("资产权属(asset_ownership)" ,"asset_ownership"));
        selectKeys.add("asset_ownership");
        entitys.add(new ExcelExportEntity("资产位置(asset_location)" ,"asset_location"));
        selectKeys.add("asset_location");
        entitys.add(new ExcelExportEntity("使用组织(current_org_id)" ,"current_org_id"));
        selectKeys.add("current_org_id");
        entitys.add(new ExcelExportEntity("单位(measurement_unit)" ,"measurement_unit"));
        selectKeys.add("measurement_unit");
        entitys.add(new ExcelExportEntity("启用日期(commissioning_date)" ,"commissioning_date"));
        selectKeys.add("commissioning_date");
        entitys.add(new ExcelExportEntity("购置日期(purchase_date)" ,"purchase_date"));
        selectKeys.add("purchase_date");
        entitys.add(new ExcelExportEntity("备注(remark)" ,"remark"));
        selectKeys.add("remark");
        entitys.add(new ExcelExportEntity("预计使用年限(expected_life)" ,"expected_life"));
        selectKeys.add("expected_life");
        entitys.add(new ExcelExportEntity("数量(quantity)" ,"quantity"));
        selectKeys.add("quantity");
        entitys.add(new ExcelExportEntity("保管用户(current_user_id)" ,"current_user_id"));
        selectKeys.add("current_user_id");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(AssetConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.addAll(visualImportModel.getList());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        exportParams.setFreezeCol(1);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(AssetConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                    list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
                }

                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }

            String fileName = menuFullName + "错误报告_" + DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ActionResult.success(vo);
    }
    /**
     * 删除
     * @param id
     * @return
     */
    @Operation(summary = "删除")
    @DeleteMapping("/{id}")
    @Transactional
    public ActionResult delete(@PathVariable("id") String id,@RequestParam(name = "forceDel",defaultValue = "false") boolean forceDel) throws Exception{
        AssetEntity entity= assetService.getInfo(id);
        if(entity!=null){
            //假删除
            entity.setDeleteMark(1);
            entity.setDeleteUserId(userProvider.get().getUserId());
            entity.setDeleteTime(new Date());
            assetService.setIgnoreLogicDelete().updateById(entity);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
     * 批量删除
     * @param obj
     * @return
     */
    @DeleteMapping("/batchRemove")
    @Transactional
    @Operation(summary = "批量删除")
    public ActionResult batchRemove(@RequestBody Object obj){
        Map<String, Object> objectMap = JsonUtil.entityToMap(obj);
        List<String> idList = JsonUtil.getJsonToList(objectMap.get("ids"), String.class);
        String errInfo = "";
        List<String> successList = new ArrayList<>();
        for (String allId : idList){
            try {
                this.delete(allId,false);
                successList.add(allId);
            } catch (Exception e) {
                errInfo = e.getMessage();
            }
        }
        if (successList.size() == 0 && StringUtil.isNotEmpty(errInfo)){
            return ActionResult.fail(errInfo);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
     * 编辑
     * @param id
     * @param assetForm
     * @return
     */
    @PutMapping("/{id}")
    @Operation(summary = "更新")
    public ActionResult update(@PathVariable("id") String id,@RequestBody @Valid AssetForm assetForm,
                               @RequestParam(value = "isImport", required = false) boolean isImport){
        AssetEntity entity= assetService.getInfo(id);
        if(entity!=null){
            assetForm.setAssetId(String.valueOf(entity.getAssetId()));

            if (!isImport) {
                String b =  assetService.checkForm(assetForm,1);
                if (StringUtil.isNotEmpty(b)){
                    return ActionResult.fail(b );
                }
            }

            try{
                assetService.saveOrUpdate(assetForm,id,false);
            }catch (DataException e1){
                return ActionResult.fail(e1.getMessage());
            }catch(Exception e){
                return ActionResult.fail(MsgCode.FA029.get());
            }
            return ActionResult.success(MsgCode.SU004.get());
        }else{
            return ActionResult.fail(MsgCode.FA002.get());
        }
    }
    /**
     * 表单信息(详情页)
     * 详情页面使用-转换数据
     * @param id
     * @return
     */
    @Operation(summary = "表单信息(详情页)")
    @GetMapping("/detail/{id}")
    public ActionResult detailInfo(@PathVariable("id") String id){
        AssetEntity entity= assetService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> assetMap=JsonUtil.entityToMap(entity);
        assetMap.put("id", assetMap.get("asset_id"));
        //副表数据
        //子表数据
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        assetMap = generaterSwapUtil.swapDataDetail(assetMap,AssetConstant.getFormData(),"818770027560829701",isPc?false:false);
        assetMap.put("supplier_id", companyService.getInfo(assetMap.get("supplier_id").toString()).getCompanyName());
        //子表数据
        return ActionResult.success(assetMap);
    }
    /**
     * 获取详情(编辑页)
     * 编辑页面使用-不转换数据
     * @param id
     * @return
     */
    @Operation(summary = "信息")
    @GetMapping("/{id}")
    public ActionResult info(@PathVariable("id") String id){
        AssetEntity entity= assetService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> assetMap=JsonUtil.entityToMap(entity);
        assetMap.put("id", assetMap.get("asset_id"));
        //副表数据
        //子表数据
        assetMap = generaterSwapUtil.swapDataForm(assetMap,AssetConstant.getFormData(),AssetConstant.TABLEFIELDKEY,AssetConstant.TABLERENAMES);
        return ActionResult.success(assetMap);
    }

}
